@echo off
setlocal
rem Build WIX installer (.msi) for specified architecture(s)
rem
rem usage: %0 {dest-path-for-msi-files Proc-Arch}

rem *** REQUIRES nmake, common invocation from Visual C or DDK command window

set OS=wxp

if "%1" == "" (
    set DST=%SystemRoot%\temp
) else (
    set DST=%1
)
if "%2" == "" (
    set ARCH=x86
    goto OK_arch
)
if "%2" == "all"  (
    set ARCH=x86
) else (
    if not "%2" == "x86" (
        echo %0 - x86 only!
        exit /B 1
    )
    set ARCH=%2
)
:OK_arch

if NOT EXIST %DST% (
    echo %0: Installer output path %DST% not found?
    exit /B 1
)
nmake /NOLOGO /? > %DST%\jnk.txt
if ERRORLEVEL 1 (
    echo %0 missing nmake.exe in PATH?
    exit /B 1
)
del /Q /F %DST%\jnk.txt

for %%a in ( %ARCH% ) do (
    if NOT EXIST %CD%\bin\HCA\%%a (
        echo %0 - %CD%\bin\HCA\%%a not populated correctly?, abort.
        exit /B 1
    )
    if EXIST %%a\OFED_%OS%_%%a.msi del /Q /F %%a\OFED_%OS%_%%a.msi
    pushd %%a
    nmake /NOLOGO full
    if ERRORLEVEL 1 (
        echo %0 - Error building OFED_%OS%_%%a.msi ?
        exit /B 1
    )
    echo move /Y OFED_%OS%_%%a.msi %DST%
    move /Y OFED_%OS%_%%a.msi %DST%
    popd
)

rem if run from top-level %1 will not be null, otherwise assume run from
rem cmd line.
if "%1" == ""   dir %DST%\*.msi

echo ----
echo Done - %OS% WIX installers in %DST%
echo ----

endlocal
