;/*++
;=============================================================================
;Copyright (c) 2007 Mellanox Technologies
;
;Module Name:
;
;    ev_log.mc
;
;Abstract:
;
;    MLX4 Driver event log messages
;
;Authors:
;
;    Leonid Keller
;
;Environment:
;
;   Kernel Mode .
;
;=============================================================================
;--*/
;
MessageIdTypedef = NTSTATUS

SeverityNames = (
	Success			= 0x0:STATUS_SEVERITY_SUCCESS
	Informational	= 0x1:STATUS_SEVERITY_INFORMATIONAL
	Warning			= 0x2:STATUS_SEVERITY_WARNING
	Error			= 0x3:STATUS_SEVERITY_ERROR
	)

FacilityNames = (
	System			= 0x0
	RpcRuntime		= 0x2:FACILITY_RPC_RUNTIME
	RpcStubs		= 0x3:FACILITY_RPC_STUBS
	Io				= 0x4:FACILITY_IO_ERROR_CODE
	MLX4			= 0x8:FACILITY_MLX4_ERROR_CODE
	)


MessageId=0x0001 Facility=MLX4 Severity=Informational SymbolicName=EVENT_MLX4_ANY_INFO
Language=English
%2
.

MessageId=0x0002 Facility=MLX4 Severity=Warning SymbolicName=EVENT_MLX4_ANY_WARN
Language=English
%2
.
MessageId=0x0003 Facility=MLX4 Severity=Error SymbolicName=EVENT_MLX4_ANY_ERROR
Language=English
%2
.

MessageId=0x0004 Facility=MLX4 Severity=Error SymbolicName=EVENT_MLX4_ERROR_LIFEFISH_OK
Language=English
mlx4_bus has started in non-operational mode. 
.

MessageId=0x0005 Facility=MLX4 Severity=Error SymbolicName=EVENT_MLX4_ERROR_LIFEFISH_FAIL
Language=English
mlx4_bus has failed to start even in non-operational mode.%n
Look into the the previous error messages.
.

MessageId=0x0006 Facility=MLX4 Severity=Informational SymbolicName=EVENT_MLX4_INFO_DEV_STARTED
Language=English
mlx4_bus has been successfully started.%n
The device parameters are:%n
   vendor_id      %t%2%n
   device_id      %t%3%n
   subvendor_id   %t%4%n
   subsystem_id   %t%5%n
   HW revision    %t%6%n
   FW version     %t%7.%8.%9%n
   HCA guid       %t%10%11%n
   HCA location   %t'%12'%n
   port number    %t%13%n
   port1 type     %t%14%n
   port2 type     %t%15.
.

MessageId=0x0007 Facility=MLX4 Severity=Error SymbolicName=EVENT_MLX4_ERROR_MAP_FA
Language=English
MAP_FA command failed with error %2.%n 
The adapter card is non-functional.%n
Most likely a FW problem.%n
Please burn the last FW and restart the mlx4_bus driver.
.

MessageId=0x0008 Facility=MLX4 Severity=Error SymbolicName=EVENT_MLX4_ERROR_RUN_FW
Language=English
RUN_FW command failed with error %2.%n
The adapter card is non-functional.%n
Most likely a FW problem.%n
Please burn the last FW and restart the mlx4_bus driver.
.

MessageId=0x0009 Facility=MLX4 Severity=Error SymbolicName=EVENT_MLX4_ERROR_QUERY_FW
Language=English
QUERY_FW command failed with error %2.%n
The adapter card is non-functional.%n
Most likely a FW problem.%n
Please burn the last FW and restart the mlx4_bus driver.
.

MessageId=0x000a Facility=MLX4 Severity=Warning SymbolicName=EVENT_MLX4_WARN_QUERY_FW
Language=English
Function disabled.%n
This device is multi-functional.%n
Please upgrade to a multi-function driver.
.

MessageId=0x000b Facility=MLX4 Severity=Error SymbolicName=EVENT_MLX4_ERROR_QUERY_DEV_CAP
Language=English
QUERY_DEV_CAP command failed with error %2.%n
The adapter card is non-functional.%n
Most likely a FW problem.%n
Please burn the last FW and restart the mlx4_bus driver.
.

MessageId=0x000c Facility=MLX4 Severity=Error SymbolicName=EVENT_MLX4_ERROR_QUERY_ADAPTER
Language=English
QUERY_ADAPTER command failed with error %2.%n
The adapter card is non-functional.%n
Most likely a FW problem.%n
Please burn the last FW and restart the mlx4_bus driver.
.

MessageId=0x000d Facility=MLX4 Severity=Error SymbolicName=EVENT_MLX4_ERROR_NOT_ENOUGH_QPS
Language=English
Too few QPs were requested (requested %2, reserved for FW %3).%n
The adapter card is non-functional.%n
Please increase the Registry LogNumQp parameter under HKLM\System\CurrentControlSet\Services\mlx4_bus\Parameters.
.

MessageId=0x000e Facility=MLX4 Severity=Informational SymbolicName=EVENT_MLX4_INFO_RESET_START
Language=English
Performing HCA restart ...
.

MessageId=0x000f Facility=MLX4 Severity=Informational SymbolicName=EVENT_MLX4_INFO_RESET_END
Language=English
HCA restart finished. Notifying the clients ...
.

MessageId=0x0010 Facility=MLX4 Severity=Warning SymbolicName=EVENT_MLX4_WARN_REG_ACTION
Language=English
%2 failed on %3 with status %4.
.

MessageId=0x0011 Facility=MLX4 Severity=Warning SymbolicName=EVENT_MLX4_WARN_REG_OPEN_DEV_KEY
Language=English
WdfDeviceOpenRegistryKey failed on opening SW (=driver) key for mlx4_bus with status %2.
.

MessageId=0x0012 Facility=MLX4 Severity=Warning SymbolicName=EVENT_MLX4_WARN_INVALID_PORT_TYPE_VALUE
Language=English
PortType registry parameter contains invalid value, PortType = %2.
.


