/*++

Copyright (c) 2005-2009 Mellanox Technologies. All rights reserved.

Module Name:
	bus_stat.h

Abstract:
	Statistics Collector header file

Revision History:

Notes:

--*/

#include <wdf.h>
#include "l2w.h"
#include "ib_pack.h"
#include "qp.h"
#include "device.h"

//
// restrictions
//

#define MLX4_ST_MAX_DEVICES			8

//
// enums
// 

#define MLX4_MAD_TRACE_LRH			(1 << 0)
#define MLX4_MAD_TRACE_BTH			(1 << 1)
#define MLX4_MAD_TRACE_DETH			(1 << 2)
#define MLX4_MAD_TRACE_GRH			(1 << 3)
#define MLX4_MAD_TRACE_WQE			(1 << 4)
#define MLX4_MAD_TRACE_UDH			(1 << 5)
#define MLX4_MAD_TRACE_WR			(1 << 6)
#define MLX4_MAD_TRACE_MLX_WQE_DUMP	(1 << 7)



//
// structures
//

// device

typedef struct _MLX4_ST_DEVICE
{
	boolean_t			valid;
	PFDO_DEVICE_DATA	p_fdo;
	WDFDEVICE			h_wdf_device;
	ULONG				flags;
	
} MLX4_ST_DEVICE, *PMLX4_ST_DEVICE;

// driver
typedef struct _MLX4_ST_DRIVER
{
	GLOBALS				*p_globals;
	WDFDRIVER			h_wdf_driver;	
	
} MLX4_ST_DRIVER, *PMLX4_ST_DRIVER;

// driver stack

typedef struct _MLX4_ST_STAT
{
	MLX4_ST_DRIVER		drv;
	MLX4_ST_DEVICE		dev[MLX4_ST_MAX_DEVICES];
	
} MLX4_ST_STAT, *PMLX4_ST_STAT;

extern MLX4_ST_STAT g_stat;

void st_print_mlx_header( struct mlx4_dev *mdev, struct mlx4_ib_sqp *sqp, struct mlx4_wqe_mlx_seg *mlx );

void st_print_mlx_send(struct mlx4_dev *mdev, struct ib_qp *ibqp, ib_send_wr_t *wr);

void st_dev_rmv( PMLX4_ST_DEVICE p_stat );

PMLX4_ST_DEVICE st_dev_add();

#pragma once
